#!/usr/bin/perl -w
# Ping Reset 1.1
# Written by Craig Maloney
# (C) 2004 Craig Maloney
# Released under the GPL.
# Checks a link to see if it is active by performing several http requests
# Succeeds if one of them returns
# Resets the link if none of them return with results
# 

use LWP::UserAgent;
$ua = LWP::UserAgent->new;
$ua->agent("MyApp/0.1 ");

$debug = 0;
$counter = 0;
# Listing of servers to try before we declare link failure
@server_list = ("http://", "http://", "http://", "http://");

foreach $server (@server_list) {
	# Create a request
	print "$server\n" if $debug;
	last if ($counter > 0); 

	my $req = HTTP::Request->new(GET => $server);
	$req->content_type('text/html');
	$req->content('match=www&errors=0');

	# Pass request to the user agent and get a response back
	my $res = $ua->request($req);

	# Check the outcome of the response
	if (($res->is_success)) {
		$counter++;
	}
}

if ($counter < 1) {
	print "Can't reach ppp0 server. Resetting the link.\n";
	$result = system("/sbin/ifdown ppp0");
	if ($result == 0) {
		$result = system("/sbin/ifup ppp0");
		if ($result == 0) {
			print "Link Reset.\n";
		}
	}
} 
